function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["index", "__is_group", "children", "__is_drag_sort"],
  _excluded2 = ["title", "editable", "children", "dataIndex", "field_type", "record", "handleSave", "lock", "render"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { Form, Tooltip } from 'antd';
import { useSortable } from '@dnd-kit/sortable';
import { CSS } from '@dnd-kit/utilities';
import { MenuOutlined } from '@ant-design/icons';
import classNames from 'classnames';
import React, { useMemo } from 'react';
import CellProvider from "./CellProvider";
import { getText } from "../../../../../locales";
import "./index.less";
export var EditableContext = /*#__PURE__*/React.createContext(null);
var EditableRow = function EditableRow(_ref) {
  var index = _ref.index,
    __is_group = _ref.__is_group,
    children = _ref.children,
    __is_drag_sort = _ref.__is_drag_sort,
    props = _objectWithoutProperties(_ref, _excluded);
  var _Form$useForm = Form.useForm(),
    _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
    form = _Form$useForm2[0];
  var parentForm = Form.useFormInstance();
  var order_by = Form.useWatch('order_by', parentForm);
  var _useSortable = useSortable({
      id: props['data-row-key']
    }),
    attributes = _useSortable.attributes,
    listeners = _useSortable.listeners,
    setNodeRef = _useSortable.setNodeRef,
    setActivatorNodeRef = _useSortable.setActivatorNodeRef,
    transform = _useSortable.transform,
    transition = _useSortable.transition,
    isDragging = _useSortable.isDragging;
  var style = _objectSpread(_objectSpread({}, props.style), {}, {
    transform: CSS.Transform.toString(transform && _objectSpread(_objectSpread({}, transform), {}, {
      scaleY: 1
    })),
    transition: transition
  }, isDragging && __is_drag_sort ? {
    position: 'relative',
    zIndex: 9999
  } : {});
  var cells = useMemo(function () {
    if (__is_group) {
      return children;
    }
    return React.Children.map(children, function (child) {
      if (child.key === '__sort') {
        var handleIcon = order_by ? /*#__PURE__*/React.createElement(Tooltip, {
          title: getText('table-column-drag-sort-disabled-tip')
        }, /*#__PURE__*/React.createElement(MenuOutlined, {
          className: "pisell-lowcode-menu-out-lined-icon"
        })) : /*#__PURE__*/React.createElement(MenuOutlined, _extends({
          ref: setActivatorNodeRef,
          className: "pisell-lowcode-menu-out-lined-icon"
        }, listeners));
        return /*#__PURE__*/React.cloneElement(child, {
          children: handleIcon
        });
      }
      return child;
    });
  }, [__is_group, children, order_by, setActivatorNodeRef, listeners]);
  return /*#__PURE__*/React.createElement(Form, {
    form: form,
    component: false
  }, /*#__PURE__*/React.createElement(EditableContext.Provider, {
    value: form
  }, __is_group && /*#__PURE__*/React.createElement("tr", {
    style: {
      height: 12
    }
  }), /*#__PURE__*/React.createElement("tr", _extends({}, props, {
    ref: setNodeRef,
    style: style
  }, attributes), cells)));
};
var EditableCell = function EditableCell(props) {
  var title = props.title,
    editable = props.editable,
    children = props.children,
    dataIndex = props.dataIndex,
    field_type = props.field_type,
    record = props.record,
    handleSave = props.handleSave,
    lock = props.lock,
    render = props.render,
    restProps = _objectWithoutProperties(props, _excluded2);
  return /*#__PURE__*/React.createElement("td", _extends({}, restProps, {
    className: classNames(restProps.className, 'ant-table-cell', 'materials-grid-table-cell')
  }), /*#__PURE__*/React.createElement(CellProvider, props));
};
export default {
  Row: EditableRow,
  Coll: EditableCell
};